<?php
/* Name: export.php
 * Purpose: Migrate data between servers (currently only supports import). Named export.php for legacy reasons.
 * Written By: Shaddi Hasan
 * Last Modified: March 24, 2009
 *
 * (c) 2009 Shaddi Hasan.
 *
 * This file is part of OrangeMesh.
 *
 * OrangeMesh is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. This license is similar to the GNU
 * General Public license, but also requires that if you extend this code and
 * use it on a publicly accessible server, you must make available the
 * complete source source code, including your extensions.
 *
 * OrangeMesh is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with OrangeMesh.  If not, see <http://www.gnu.org/licenses/>.
 */

//Start session
session_start();
if ($_SESSION['user_type']!='admin')
header("Location: ../entry/login.php");

if(empty($_POST['host']) || empty($_POST['network']) || empty($_POST['password'])) {
	show_form();
} else {
	do_request($_POST['host'],$_POST['network'],$_POST['password']);
}

function do_request($host,$network,$password) {
	require 'HTTP/Request.php';
	$rq =& new HTTP_Request($host);
	$rq->setMethod(HTTP_REQUEST_METHOD_POST);
	$rq->addPostData("network",$network);
	$rq->addPostData("passwd",$password);

	if (!PEAR::isError($rq->sendRequest())) {
		$response = $rq->getResponseBody();
	} 
	
	if(empty($response)) {
		die("no response!");
	} 

	process_xml($response);

	header("Location: ../migration/export.php?u=success");
}

function process_xml($response) {
	require '../lib/connectDB.php';
	setTable('node');

	//fix for old databases: make mac address a unique key; yes I know it's a hack
	$query = "ALTER TABLE `node` ADD UNIQUE (`mac`)";
	mysql_query($query, $conn) or die("Error executing query: ".mysql_error($conn));


	//echo $response;
	$xml = new SimpleXMLElement($response);
	if(empty($_SESSION['netid'])) { die("no netid in session!"); }
	$netid = $_SESSION['netid'];

	foreach($xml->node as $node) {
		$values = array();
		$values[] = mysql_real_escape_string($node->mac);
		$values[] = mysql_real_escape_string($netid);
		$values[] = mysql_real_escape_string($node->name);
		$values[] = mysql_real_escape_string($node->notes);
		$values[] = mysql_real_escape_string($node->lat);
		$values[] = mysql_real_escape_string($node->lng);
		$values[] = mysql_real_escape_string("A");	//automatically accept nodes
		

		$vals = implode("','",$values);
		$fields = array('mac','netid','name','description','latitude','longitude','approval_status');
		$fields = implode(",",$fields);

		$query = "REPLACE INTO node (".$fields.") VALUES('".$vals."')";
		//echo $query."<br>";	//uncomment to see the raw queries being sent to your DB

		//execute the query
		mysql_query($query, $conn) or die("Error executing query: ".mysql_error($conn));
	}

	$query = "ALTER TABLE `node` DROP INDEX `mac`";
	mysql_query($query, $conn) or die("Error executing query: ".mysql_error($conn));

}


function show_form() {
	include '../lib/menu.php';

	?>
<html>
<head>
<title>Migrate Network</title>

	<?php
	include "../lib/style.php";
	$updated = ($_GET['u']=="success");
	if ($updated==true) echo "<div class=success>Nodes successfully imported!</div>";

	?>
</head>
<body>
<p>
Enter the host and login information to import nodes to the <?php echo $_SESSION['net_name']." "; ?>network. The default hostname will work if you're importing from open-mesh.com.
</p>
<p>
<b>Warning!</b> Duplicate node entries will be overwritten by the imported
data.
</p>
<form method="POST" action="export.php" name="export">Host: <input
	name="host" value="http://www.open-mesh.com/export_nodes.php"><br>
Network: <input name="network"><br>
Password: <input type="password" name="password"><br>
<input type="submit" name="submit" value="submit"></form>
</body>
</html>
	<?php
}

?>
